<?php
/*
TimThumb Version Check
Copyright 2012-2013 White Fir Design (http://www.whitefirdesign)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; only version 2 of the License is applicable.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (PHP_SAPI == "cli") 
	echo "\nTimThumb Version Check by White Fir Design (www.whitefirdesign.com)";
else
	echo "<html>\n<head>\n<title>TimThumb Version Check by White Fir Design (www.whitefirdesign.com)</title>\n<meta name=\"robots\" content=\"noindex\" />\n</head>\n<body>\n\n<p><b>TimThumb Version Check</b> by <a href=\"http://www.whitefirdesign.com\">White Fir Design</a></p>\n\n";

//checks if PHP version is 5.0 or above
if (phpversion() < "5.0") {
	echo "You are running version ".phpversion()." of PHP, you need PHP 5 or above to use this.";
	exit();
}

if (((isset($_GET['directory'])) && $_GET['directory']!="") || (isset($argc) && $argc == 2 && (!in_array($argv[1], array('--help', '-help', '-h', '-?'))) )) {
	if (isset($_GET['directory']))
		$basepath = $_GET['directory'];
	else
		$basepath = $argv[1];
	if (is_dir($basepath)) {
		if (isset($_GET['directory']))
			echo "<br /><b>Scanning from ".htmlspecialchars($basepath).":</b><br /><br />";
		else
			echo "\n\n\nScanning from ".htmlspecialchars($basepath).":\n\n";
		$filecount = 0;
		$objects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($basepath), RecursiveIteratorIterator::SELF_FIRST);
		foreach($objects as $object){
		
			if ($object->isFile() && stripos($object->getFilename(),".php") && $object->getPathname() != __FILE__) {
				$filecount++;
				$path = $object->getPathname();
				$file = file_get_contents($object->getPathname());
				
				if (strpos($file,"code.google.com/p/timthumb/")) {
					preg_match("/VERSION', '([0-9.]+)'/", $file, $version);
					if (isset($version[1])) {
					
						if (@$_SERVER['argc'] >= 1) {
							echo "File: $path\n";
							echo "Version: ";
							echo $version[1];
							echo "\n\n";
						}
						else {
							echo "<b>File:</b> $path<br />\n";
							echo "<b>Version:</b>: ";
							echo $version[1];
							echo "<br /><br />\n\n";
						}
					}
				}
			}
		}

		if (PHP_SAPI == "cli") 
			echo $filecount." Files Scanned\n";
		else
			echo $filecount." Files Scanned<br /><br />";
	}
	else {
		if (PHP_SAPI == "cli")
			echo "\n\n\nDirectory ".htmlspecialchars($basepath)." does not exist.\n";
		else	
			echo "<br /><b>Directory ".htmlspecialchars($basepath)." does not exist.</b><br /><br />";
	}
}
if (PHP_SAPI == "cli") {
	echo "\n\nUsage: ".$argv[0]." <directory to scan>";
	echo "\nThe current directory is ".getcwd()."\n";
}
else {
	echo "<br /><b>Run scan on:</b><br />";
	echo "<form method=\"get\" action=\"".basename(__FILE__)."\">";
	echo "<input type=\"text\" name=\"directory\" size=\"50\" value=\"".getcwd()."\" />";
	echo "<input type=\"submit\" value=\"Scan\" />";
	echo "<br />Current Directory: ".getcwd()."<br />";
	echo "</form>";
	echo "\n</body>";
	echo "\n</html>";
}

?>